if select(2, UnitClass("player")) ~= "DRUID" then return end
local damageTable = {}
local updateInterval = 0.1
local eventIndex = 0
local playerGUID
local timeElapsed = 0
local damageTP5S = 0

local frenzyRegenFrame = CreateFrame("Frame", "renzyRegenFrame", UIParent)
frenzyRegenFrame:SetSize(100, 26)
frenzyRegenFrame:SetPoint("CENTER", UIParent)
frenzyRegenFrame:SetBackdrop({
    bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 12,
    insets = { left = 3, right = 3, top = 3, bottom = 3, },
})

frenzyRegenFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
frenzyRegenFrame:RegisterEvent("ADDON_LOADED")
frenzyRegenFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")

frenzyRegenFrame:EnableMouse(true)
frenzyRegenFrame:SetMovable(true)
frenzyRegenFrame:RegisterForDrag("LeftButton")
frenzyRegenFrame:SetScript("OnDragStart", frenzyRegenFrame.StartMoving)
frenzyRegenFrame:SetScript("OnDragStop", frenzyRegenFrame.StopMovingOrSizing)

frenzyRegenFrame.damageTakenBar = CreateFrame("StatusBar", nil, frenzyRegenFrame)
frenzyRegenFrame.damageTakenBar:SetPoint("TOPLEFT", 3, -3)
frenzyRegenFrame.damageTakenBar:SetPoint("TOPRIGHT", -3, -3)
frenzyRegenFrame.damageTakenBar:SetHeight(20)
frenzyRegenFrame.damageTakenBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
frenzyRegenFrame.damageTakenBar:GetStatusBarTexture():SetHorizTile(false)
frenzyRegenFrame.damageTakenBar:GetStatusBarTexture():SetVertTile(false)
frenzyRegenFrame.damageTakenBar:SetMinMaxValues(0, 100)
frenzyRegenFrame.damageTakenBar:SetStatusBarColor(0, 0.65, 0)


frenzyRegenFrame.damageTakenBar.bg = frenzyRegenFrame.damageTakenBar:CreateTexture(nil, "BACKGROUND")
frenzyRegenFrame.damageTakenBar.bg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
frenzyRegenFrame.damageTakenBar.bg:SetAllPoints(true)
frenzyRegenFrame.damageTakenBar.bg:SetVertexColor(0, 0.35, 0)

frenzyRegenFrame.damageTakenBar.value = frenzyRegenFrame.damageTakenBar:CreateFontString(nil, "OVERLAY")
frenzyRegenFrame.damageTakenBar.value:SetPoint("CENTER", frenzyRegenFrame.damageTakenBar, "CENTER", 4, 0)
frenzyRegenFrame.damageTakenBar.value:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
frenzyRegenFrame.damageTakenBar.value:SetJustifyH("LEFT")
frenzyRegenFrame.damageTakenBar.value:SetShadowOffset(1, -1)
frenzyRegenFrame.damageTakenBar.value:SetTextColor(0, 1, 0)

function frenzyRegenFrame:countHealing()
  maxHP = UnitHealthMax("player")
 
  --mastery, coefficient = GetMasteryEffect()
  versatilityBonus = GetCombatRatingBonus(CR_VERSATILITY_DAMAGE_DONE) + GetVersatilityBonus(CR_VERSATILITY_DAMAGE_DONE)
  expectedHealing =  math.max(maxHP*0.05,damageTP5S*0.5)*(1+versatilityBonus/100)
  
  local t18set = {124246, 124255, 124261, 124267, 124272}
  local t18items = 0
  for i=1,5,1 do
    if IsEquippedItem(t18set[i]) then
        t18items = t18items + 1
    end    
  end
  isT18eq = t18items > 1  
  
  local idx = 1
  repeat
    local name, _, _, _, _, _, _, _, _, _, spellID = UnitAura("player", idx, nil, "PLAYER|HELPFUL|CANCELABLE")
    if spellID and spellID == 213680 then          
      expectedHealing = expectedHealing*1.2
    elseif isT18eq and spellID and spellID == 192081 then
      expectedHealing = expectedHealing*1.2
    end
    idx = idx + 1
  until name == nil
  
  ratioHP = expectedHealing/maxHP*100  
  frenzyRegenFrame.damageTakenBar:SetValue(ratioHP)
  if displayFlag == 0 then
    frenzyRegenFrame.damageTakenBar.value:SetText(format("%d", expectedHealing))
  elseif displayFlag == 1 then
    frenzyRegenFrame.damageTakenBar.value:SetText(format("%d", expectedHealing/6))
  else if displayFlag == 2 then  
  frenzyRegenFrame.damageTakenBar.value:SetText(format("%d%%", ratioHP))  
  end
  end 
end

function frenzyRegenFrame:updateVisibility()
  if IsPlayerSpell(22842) then
    self:Show()  
  else
    self:Hide()   
  end
end

frenzyRegenFrame:SetScript("OnEvent",
  function(self, event,  ...)
  if event == "ADDON_LOADED"  then
    playerGUID = UnitGUID("player")
    if displayFlag == nil then
      displayFlag = 0;
    end
    frenzyRegenFrame:updateVisibility()
  elseif self:IsShown() and event == "COMBAT_LOG_EVENT_UNFILTERED" then	
		local _, eventType, _, sourceGUID, _, _, _, destGUID = ...   
    if destGUID == playerGUID then
      eventIndex = eventIndex + 1  
      if eventType == "SWING_DAMAGE" then
        local _, _, _, _, _, _, _, _, _, _, _, amount, _, _, _, _, absorbed = ...
        if absorbed == nil then
          absorbed = 0;
        end
        damageTable[eventIndex] = {time(), amount+absorbed}      
       elseif eventType == "SPELL_DAMAGE" or eventType == "SPELL_PERIODIC_DAMAGE" or eventType == "RANGE_DAMAGE" then
        local _, _, _, _, _, _, _, _, _, _, _, _, _, _, amount, _, _, _, _, absorbed = ...
        if absorbed == nil then
          absorbed = 0;
        end
        damageTable[eventIndex] = {time(), amount+absorbed}
        end
      end 
  elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
    frenzyRegenFrame:updateVisibility()
    end
end)

frenzyRegenFrame:SetScript("OnUpdate", function(self, elapsed)
  timeElapsed = timeElapsed + elapsed
  if timeElapsed >= updateInterval then
		local t = time() - 5
		for k, v in pairs(damageTable) do
      if v[1] <= t then
        damageTable[k] = nil
      else
        damageTP5S = damageTP5S + v[2]
      end
		end		
    self:countHealing()			
		damageTP5S = 0
		timeElapsed = 0
  end
end)

local dropDown = CreateFrame("Frame", "FRContextMenu", frenzyRegenFrame, "UIDropDownMenuTemplate")
UIDropDownMenu_Initialize(dropDown, function(self, level, menuList)
 local info = UIDropDownMenu_CreateInfo()
 if (level or 1) == 1 then
  info.text = "Frame position"
  info.notCheckable = true
  info.hasArrow = true
  info.value = "position_submenu"
  UIDropDownMenu_AddButton(info)  
  info.notCheckable = false
  info.hasArrow = false
  info.text = "Show total heal"   
  info.func = function() displayFlag = 0 end
  info.checked = function() return displayFlag == 0 end
  UIDropDownMenu_AddButton(info)
  info.text = "Show heal per tick"
  info.func = function() displayFlag = 1 end
  info.checked = function() return displayFlag == 1 end
  UIDropDownMenu_AddButton(info)
  info.text = "Show % of HP"  
  info.func = function() displayFlag = 2 end     
  info.checked = function() return displayFlag == 2 end
  UIDropDownMenu_AddButton(info)
 elseif level == 2 then
  if UIDROPDOWNMENU_MENU_VALUE == "position_submenu" then
    info.text = "Block position"
    info.func = function() frenzyRegenFrame:SetMovable(not frenzyRegenFrame:IsMovable()) end
    info.checked = function() return not frenzyRegenFrame:IsMovable() end
    info.isNotRadio = true
    UIDropDownMenu_AddButton(info, level)
  end
 end
end)

frenzyRegenFrame:SetScript("OnMouseDown", function(self, button)
	if button == "RightButton" then
		ToggleDropDownMenu(1, nil, dropDown, "cursor", 3, -3)
	end
end)
